class AbstractTemplate {
    constructor(template = '') {
        this.template = '';
        this.template = template;
    }
    replaceMnemonics(info) {
        const mnemonics = this.template.match(/{{\w+}}/g) || [];
        if (!info)
            return this.template;
        let message = this.template;
        mnemonics.forEach((mnemonic) => {
            const keyRegex = new RegExp(mnemonic, 'g');
            const [key] = mnemonic.match(/\w+/g) || [];
            if (typeof key === 'string') {
                message = message.replace(keyRegex, info[key] || '');
            }
        });
        return message;
    }
    format(info) {
        return this.replaceMnemonics(info);
    }
}
export { AbstractTemplate };
export default AbstractTemplate;
