import ClientSftp from 'ssh2-sftp-client';
class Sftp {
    constructor() {
        this.isConnected = false;
        this.params = {};
        this.client = new ClientSftp();
        this.connection = null;
        const handleConnError = () => {
            this.connection = null;
            this.isConnected = false;
        };
        this.client.on('close', handleConnError);
        this.client.on('end', handleConnError);
    }
    setParams(params) {
        this.params = params;
    }
    async connect(sftpParams = null) {
        try {
            if (sftpParams) {
                this.params = sftpParams;
            }
            if (this.isConnected && this.connection) {
                return { conn: this.connection, client: this.client };
            }
            this.connection = await this.client.connect(this.params);
            this.isConnected = true;
            return { conn: this.connection, client: this.client };
        }
        catch (err) {
            return Promise.reject(err);
        }
    }
}
const instance = new Sftp();
export { instance as Sftp };
export default instance;
